/*
**	LibPanel.c
**
**	Editing panel for transfer library configuration
**
**	Copyright  1990-1993 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_DEFAULT_LIB,GAD_SELECT_DEFAULT_LIB,
		GAD_ASCII_UPLOAD_LIB,GAD_SELECT_ASCII_UPLOAD_LIB,GAD_BUILTIN_ASCII_UPLOAD,
		GAD_ASCII_DOWNLOAD_LIB,GAD_SELECT_ASCII_DOWNLOAD_LIB,GAD_BUILTIN_ASCII_DOWNLOAD,
		GAD_QUIET_TRANSFER,
		GAD_TEXT_UPLOAD_LIB,GAD_SELECT_TEXT_UPLOAD_LIB,GAD_TEXT_DOWNLOAD_LIB,GAD_SELECT_TEXT_DOWNLOAD_LIB,
		GAD_BINARY_UPLOAD_LIB,GAD_SELECT_BINARY_UPLOAD_LIB,GAD_BINARY_DOWNLOAD_LIB,GAD_SELECT_BINARY_DOWNLOAD_LIB,

		GAD_USE,GAD_CANCEL,GAD_DEFAULT };

STATIC WORD Mappings[] =
{
	GAD_SELECT_DEFAULT_LIB,
	GAD_SELECT_ASCII_UPLOAD_LIB,
	GAD_SELECT_ASCII_DOWNLOAD_LIB,
	GAD_SELECT_TEXT_UPLOAD_LIB,
	GAD_SELECT_TEXT_DOWNLOAD_LIB,
	GAD_SELECT_BINARY_UPLOAD_LIB,
	GAD_SELECT_BINARY_DOWNLOAD_LIB,
	-1
};

STATIC WORD Strings[] =
{
	GAD_DEFAULT_LIB,
	GAD_ASCII_UPLOAD_LIB,
	GAD_ASCII_DOWNLOAD_LIB,
	GAD_TEXT_UPLOAD_LIB,
	GAD_TEXT_DOWNLOAD_LIB,
	GAD_BINARY_UPLOAD_LIB,
	GAD_BINARY_DOWNLOAD_LIB,
};

STATIC struct Gadget *
CreateAllGadgets(struct Configuration *Config,struct Gadget *GadgetArray[],struct Gadget **GadgetList,BYTE *Default)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	SZ_SizeSetup(Window -> WScreen,&UserFont,TRUE);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		SZ_AddLeftOffset(SZ_LeftOffsetDelta(MSG_LIBPANEL_DEFAULT_TRANSFER_LIBRARY_GAD,MSG_LIBPANEL_BINARY_DOWNLOAD_LIBRARY_GAD));

		SZ_ResetMaxWidth();

		SZ_UpdateMaxWidth(STRING_KIND,NULL,30,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_LIBPANEL_DEFAULT_TRANSFER_LIBRARY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_LeaveFolder,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> TransferConfig -> DefaultLibrary,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FILE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_PlaceLeft,	TRUE,
		TAG_DONE);


		NewGadget . ng_GadgetText	= LocaleString(MSG_LIBPANEL_ASCII_UPLOAD_LIBRARY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_LeaveFolder,	TRUE,
			SZ_AlignExtra,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> TransferConfig -> ASCIIUploadLibrary,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FILE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_PlaceLeft,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_LIBPANEL_BUILTIN_ASCII_UPLOAD_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> TransferConfig -> InternalASCIIUpload,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_LIBPANEL_ASCII_DOWNLOAD_LIBRARY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_LeaveFolder,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> TransferConfig -> ASCIIDownloadLibrary,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FILE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_PlaceLeft,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_LIBPANEL_BUILTIN_ASCII_DOWNLOAD_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> TransferConfig -> InternalASCIIDownload,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_LIBPANEL_QUIET_TRANSFER_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> TransferConfig -> QuietTransfer,
		TAG_DONE);


		NewGadget . ng_GadgetText	= LocaleString(MSG_LIBPANEL_TEXT_UPLOAD_LIBRARY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_LeaveFolder,	TRUE,
			SZ_AlignExtra,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> TransferConfig -> TextUploadLibrary,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FILE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_PlaceLeft,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_LIBPANEL_TEXT_DOWNLOAD_LIBRARY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_LeaveFolder,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> TransferConfig -> TextDownloadLibrary,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FILE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_PlaceLeft,	TRUE,
		TAG_DONE);


		NewGadget . ng_GadgetText	= LocaleString(MSG_LIBPANEL_BINARY_UPLOAD_LIBRARY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_LeaveFolder,	TRUE,
			SZ_AlignExtra,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> TransferConfig -> BinaryUploadLibrary,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FILE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_PlaceLeft,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_LIBPANEL_BINARY_DOWNLOAD_LIBRARY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_LeaveFolder,	TRUE,

			GTST_MaxChars,	255,
			GTST_String,	Config -> TransferConfig -> BinaryDownloadLibrary,
		TAG_DONE);

		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(FILE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_PlaceLeft,	TRUE,
		TAG_DONE);

		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_USE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_CANCEL_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_DEFAULT_GAD),0,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,
			SZ_AlignLeft,	TRUE,
			SZ_AlignBottom,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignRight,	TRUE,
		TAG_DONE);

		if(Default)
		{
			NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_DEFAULT_GAD);
			NewGadget . ng_GadgetID		= Counter;

			GadgetArray[Counter] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
				SZ_Adjust,	TRUE,
				SZ_AutoWidth,	TRUE,
				SZ_AlignCentre,	TRUE,
			TAG_DONE);
		}
	}

	return(Gadget);
}

BYTE
LibPanel(struct Configuration *Config,BYTE *Default)
{
	STATIC struct Gadget	*GadgetArray[GAD_DEFAULT + 1];
	struct Gadget		*GadgetList = NULL;
	struct Window		*PanelWindow;

	SaveConfig(Config,PrivateConfig);

	if(CreateAllGadgets(Config,GadgetArray,&GadgetList,Default))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	GetScreenLeft(Window) + (GetScreenWidth(Window) - SZ_GetWindowWidth()) / 2,
			WA_Top,		GetScreenTop(Window) + (GetScreenHeight(Window) - SZ_GetWindowHeight())	/ 2,
			WA_Width,	SZ_GetWindowWidth(),
			WA_Height,	SZ_GetWindowHeight(),

			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Window -> WScreen,

			WA_IDCMP,	IDCMP_GADGETDOWN | IDCMP_ACTIVEWINDOW | IDCMP_CLOSEWINDOW | IDCMP_RAWKEY | IDCMP_VANILLAKEY | BUTTONIDCMP | STRINGIDCMP,

			WA_Title,	LocaleString(MSG_LIBPANEL_LIBRARY_PREFERENCES_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 IClass,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;

			GuideContext(CONTEXT_LIBS);

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			ActiveGadget = NULL;

			ClrSignal(SIG_BREAK);

			while(!Terminated)
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					SaveConfig(PrivateConfig,Config);

					break;
				}

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					IClass	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&IClass,&Code);

					if(IClass == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(IClass == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(IClass == IDCMP_CLOSEWINDOW)
					{
						SaveConfig(PrivateConfig,Config);

						Terminated = TRUE;
					}

					if(IClass == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_USE:

								Terminated = TRUE;

								strcpy(Config -> TransferConfig -> DefaultLibrary,		SZ_GetString(GadgetArray[GAD_DEFAULT_LIB]));
								strcpy(Config -> TransferConfig -> ASCIIUploadLibrary,		SZ_GetString(GadgetArray[GAD_ASCII_UPLOAD_LIB]));
								strcpy(Config -> TransferConfig -> ASCIIDownloadLibrary,	SZ_GetString(GadgetArray[GAD_ASCII_DOWNLOAD_LIB]));
								strcpy(Config -> TransferConfig -> TextUploadLibrary,		SZ_GetString(GadgetArray[GAD_TEXT_UPLOAD_LIB]));
								strcpy(Config -> TransferConfig -> TextDownloadLibrary,		SZ_GetString(GadgetArray[GAD_TEXT_DOWNLOAD_LIB]));
								strcpy(Config -> TransferConfig -> BinaryUploadLibrary,		SZ_GetString(GadgetArray[GAD_BINARY_UPLOAD_LIB]));
								strcpy(Config -> TransferConfig -> BinaryDownloadLibrary,	SZ_GetString(GadgetArray[GAD_BINARY_DOWNLOAD_LIB]));

								Config -> TransferConfig -> InternalASCIIUpload	= SZ_GetChecked(GadgetArray[GAD_BUILTIN_ASCII_UPLOAD]);
								Config -> TransferConfig -> InternalASCIIDownload	= SZ_GetChecked(GadgetArray[GAD_BUILTIN_ASCII_DOWNLOAD]);
								Config -> TransferConfig -> QuietTransfer		= SZ_GetChecked(GadgetArray[GAD_QUIET_TRANSFER]);

								break;

							case GAD_CANCEL:

								Terminated = TRUE;

								SaveConfig(PrivateConfig,Config);

								break;

							case GAD_DEFAULT:

								*Default	= TRUE;

								Terminated	= TRUE;

								break;

							default:
							{
								WORD Picked = -1,i;

								for(i = 0 ; Picked == -1 && Mappings[i] != -1 ; i++)
								{
									if(Gadget -> GadgetID == Mappings[i])
										Picked = i;
								}

								if(Picked != -1)
								{
									BlockWindow(PanelWindow);

									strcpy(SharedBuffer,SZ_GetString(GadgetArray[Strings[Picked]]));

									if(PickFile("Libs:","xpr#?.library",LocaleString(MSG_LIBPANEL_SELECT_DEFAULT_TRANSFER_LIBRARY_TXT + Picked),SharedBuffer))
									{
										if(Stricmp(SharedBuffer,SZ_GetString(Gadget)))
										{
											GT_SetGadgetAttrs(GadgetArray[Strings[Picked]],PanelWindow,NULL,
												GTST_String,SharedBuffer,
											TAG_DONE);
										}
									}

									ReleaseWindow(PanelWindow);
								}

								break;
							}
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}
	}

	FreeGadgets(GadgetList);

	return((BYTE)memcmp(PrivateConfig -> TransferConfig,Config -> TransferConfig,sizeof(struct TransferSettings)));
}
